# -*- python -*-
# ex: set syntax=python:

from buildbot.plugins import *

c = BuildmasterConfig = {}

c['title'] = "{{ buildbotConfig['master']['title'] }}"
c['titleURL'] = "{{ buildbotConfig['master']['titleUrl'] }}"
c['buildbotURL'] = "{{ buildbotConfig['master']['buildbotUrl'] }}"

c['slaves'] = [
{% if groups['buildbot-' + inventory_hostname] is defined %}
{% for slave in groups['buildbot-' + inventory_hostname ] %}
  buildslave.BuildSlave("{{ hostvars[slave]['buildbotConfig']['slave']['name'] }}", "{{ hostvars[slave]['buildbotConfig']['slave']['password'] }}"),
{% endfor %}
{% endif %}
  ]

c['protocols'] = {'pb': {'port': 9989}}

c['change_source'] = []
c['schedulers'] = []
c['builders'] = []

{% if buildbotConfig['master']['poller'] is defined %}
{% for poller in buildbotConfig['master']['poller'] %}
c['change_source'].append(changes.GitPoller(
  project = '{{ poller['project'] }}',
  repourl = '{{ poller['url']}}',
  branches = [
{% for branch in poller['branches'] %}
    '{{ branch }}',
{% endfor %}
  ],
  workdir = 'gitpoller-{{ poller['workdir'] }}',
  pollinterval = {{ poller['interval'] }}))
{% endfor %}
{% endif %}

{% if buildbotConfig['master']['scheduler']['nightly'] is defined %}
{% for scheduler in buildbotConfig['master']['scheduler']['nightly'] %}
c['schedulers'].append(schedulers.Nightly(
  name = '{{ scheduler['name'] }}',
  change_filter = util.ChangeFilter(project = '{{ scheduler['project'] }}', branch = '{{ scheduler['branch'] }}'),
  branch = '{{ scheduler['branch'] }}',
  builderNames = [
{% for builder in scheduler['builderNames'] %}
    '{{ builder }}',
{% endfor %}
  ],
  hour = {{ scheduler['hour'] }}, minute = {{ scheduler['minute'] }}))
{% endfor %}
{% endif %}

{% if buildbotConfig['master']['scheduler']['change'] is defined %}
{% for scheduler in buildbotConfig['master']['scheduler']['change'] %}
c['schedulers'].append(schedulers.SingleBranchScheduler(
  name = '{{ scheduler['name'] }}',
  change_filter = util.ChangeFilter(project = '{{ scheduler['project'] }}', branch = '{{ scheduler['branch'] }}'),
  builderNames = [
{% for builder in scheduler['builderNames'] %}
    '{{ builder }}',
{% endfor %}
  ],
  treeStableTimer = {{ scheduler['treeStableTimer'] }}))
{% endfor %}
{% endif %}

{% if buildbotConfig['master']['scheduler']['periodic'] is defined %}
{% for scheduler in buildbotConfig['master']['scheduler']['periodic'] %}
c['schedulers'].append(schedulers.Periodic(
  name = '{{ scheduler['name'] }}',
  builderNames = [
{% for builder in scheduler['builderNames'] %}
    '{{ builder }}',
{% endfor %}
  ],
  periodicBuildTimer = {{ scheduler['periodicBuildTimer'] }}))
{% endfor %}
{% endif %}

{% if buildbotConfig['master']['factory'] is defined %}
{% for factory in buildbotConfig['master']['factory'] %}
factory_{{ factory['name'] }} = util.BuildFactory()

{% if factory['steps']['git'] is defined %}
{% for step in factory['steps']['git'] %}
factory_{{ factory['name'] }}.addStep(steps.Git(
  name = '{{ step['name'] }}',
  repourl = '{{ step['repourl'] }}',
  workdir = util.Interpolate('%(prop:buildnumber)s/{{ step['workdir'] | default('') }}'),
  mode = '{{ step['mode'] | default('incremental') }}',
  alwaysUseLatest = {{ step['alwaysUseLatest'] | default('False') }},
  haltOnFailure = {{ step['haltOnFailure'] | default('True') }}
  ))
{% endfor %}
{% endif %}

{% if factory['steps']['shell'] is defined %}
{% for step in factory['steps']['shell'] %}
factory_{{ factory['name'] }}.addStep(steps.ShellCommand(
  name = '{{ step['name'] }}',
  env = {'BUILDNUMBER': util.Interpolate('%(prop:buildnumber)s')},
  command = ['{{ step['command'] | regex_replace(' ', "', '") }}'],
  workdir = util.Interpolate('%(prop:buildnumber)s/{{ step['workdir'] | default('') }}'),
  timeout = {{ step['timeout'] | default('None') }},
  haltOnFailure = {{ step['haltOnFailure'] | default('True') }},
  alwaysRun = {{ step['alwaysRun'] | default('False') }}
  ))

{% endfor %}
{% endif %}

{% if factory['builder'] is defined %}
c['builders'].append(util.BuilderConfig(
  name = '{{ factory['builder']['name'] }}',
  slavenames = [
{% for slave in factory['builder']['slaves'] %}
    '{{ slave }}',
{% endfor %}
  ],
  factory = factory_{{ factory['name'] }}))
{% endif %}

{% endfor %}
{% endif %}

# STATUS TARGETS

c['status'] = []

from buildbot.status import html
from buildbot.status.web import authz, auth

authz_cfg = authz.Authz(
  auth = auth.BasicAuth([("fnordpipe", "fnordpipe")]),
  gracefulShutdown = False,
  forceBuild = 'auth', # use this to test your slave once it is set up
  forceAllBuilds = 'auth',  # ..or this
  pingBuilder = False,
  stopBuild = False,
  stopAllBuilds = False,
  cancelPendingBuild = False)
c['status'].append(html.WebStatus(http_port = 8010, authz = authz_cfg))

# database

c['db'] = {
  'db_url' : "sqlite:///state.sqlite",
}
